<?php
/**
 * InlineResponse20079ContentAllOfAllOfGuarantee
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Model;

use \ArrayAccess;
use \SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * InlineResponse20079ContentAllOfAllOfGuarantee Class Doc Comment
 *
 * @category Class
 * @description Information of the guarantee or warranty of a device
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class InlineResponse20079ContentAllOfAllOfGuarantee implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'inline_response_200_79_content_allOf_allOf_guarantee';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'linkTypeId' => 'int',
        'linkId' => 'int',
        'purchaseDate' => 'int',
        'guaranteeMonth' => 'int',
        'guaranteeExpire' => 'int',
        'warrantyMonth' => 'int',
        'warrantyExpire' => 'int',
        'remark' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'linkTypeId' => null,
        'linkId' => null,
        'purchaseDate' => 'timestamp',
        'guaranteeMonth' => null,
        'guaranteeExpire' => 'timestamp',
        'warrantyMonth' => null,
        'warrantyExpire' => 'timestamp',
        'remark' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'linkTypeId' => 'linkTypeId',
        'linkId' => 'linkId',
        'purchaseDate' => 'purchaseDate',
        'guaranteeMonth' => 'guaranteeMonth',
        'guaranteeExpire' => 'guaranteeExpire',
        'warrantyMonth' => 'warrantyMonth',
        'warrantyExpire' => 'warrantyExpire',
        'remark' => 'remark'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'linkTypeId' => 'setLinkTypeId',
        'linkId' => 'setLinkId',
        'purchaseDate' => 'setPurchaseDate',
        'guaranteeMonth' => 'setGuaranteeMonth',
        'guaranteeExpire' => 'setGuaranteeExpire',
        'warrantyMonth' => 'setWarrantyMonth',
        'warrantyExpire' => 'setWarrantyExpire',
        'remark' => 'setRemark'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'linkTypeId' => 'getLinkTypeId',
        'linkId' => 'getLinkId',
        'purchaseDate' => 'getPurchaseDate',
        'guaranteeMonth' => 'getGuaranteeMonth',
        'guaranteeExpire' => 'getGuaranteeExpire',
        'warrantyMonth' => 'getWarrantyMonth',
        'warrantyExpire' => 'getWarrantyExpire',
        'remark' => 'getRemark'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }


    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['linkTypeId'] = $data['linkTypeId'] ?? null;
        $this->container['linkId'] = $data['linkId'] ?? null;
        $this->container['purchaseDate'] = $data['purchaseDate'] ?? null;
        $this->container['guaranteeMonth'] = $data['guaranteeMonth'] ?? null;
        $this->container['guaranteeExpire'] = $data['guaranteeExpire'] ?? null;
        $this->container['warrantyMonth'] = $data['warrantyMonth'] ?? null;
        $this->container['warrantyExpire'] = $data['warrantyExpire'] ?? null;
        $this->container['remark'] = $data['remark'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets linkTypeId
     *
     * @return int|null
     */
    public function getLinkTypeId()
    {
        return $this->container['linkTypeId'];
    }

    /**
     * Sets linkTypeId
     *
     * @param int|null $linkTypeId link type id of the assignment
     *
     * @return self
     */
    public function setLinkTypeId($linkTypeId)
    {
        $this->container['linkTypeId'] = $linkTypeId;

        return $this;
    }

    /**
     * Gets linkId
     *
     * @return int|null
     */
    public function getLinkId()
    {
        return $this->container['linkId'];
    }

    /**
     * Sets linkId
     *
     * @param int|null $linkId link id of the assignment
     *
     * @return self
     */
    public function setLinkId($linkId)
    {
        $this->container['linkId'] = $linkId;

        return $this;
    }

    /**
     * Gets purchaseDate
     *
     * @return int|null
     */
    public function getPurchaseDate()
    {
        return $this->container['purchaseDate'];
    }

    /**
     * Sets purchaseDate
     *
     * @param int|null $purchaseDate date when this device was purchased
     *
     * @return self
     */
    public function setPurchaseDate($purchaseDate)
    {
        $this->container['purchaseDate'] = $purchaseDate;

        return $this;
    }

    /**
     * Gets guaranteeMonth
     *
     * @return int|null
     */
    public function getGuaranteeMonth()
    {
        return $this->container['guaranteeMonth'];
    }

    /**
     * Sets guaranteeMonth
     *
     * @param int|null $guaranteeMonth number of months (device guarantee)
     *
     * @return self
     */
    public function setGuaranteeMonth($guaranteeMonth)
    {
        $this->container['guaranteeMonth'] = $guaranteeMonth;

        return $this;
    }

    /**
     * Gets guaranteeExpire
     *
     * @return int|null
     */
    public function getGuaranteeExpire()
    {
        return $this->container['guaranteeExpire'];
    }

    /**
     * Sets guaranteeExpire
     *
     * @param int|null $guaranteeExpire date when the guarantee expires
     *
     * @return self
     */
    public function setGuaranteeExpire($guaranteeExpire)
    {
        $this->container['guaranteeExpire'] = $guaranteeExpire;

        return $this;
    }

    /**
     * Gets warrantyMonth
     *
     * @return int|null
     */
    public function getWarrantyMonth()
    {
        return $this->container['warrantyMonth'];
    }

    /**
     * Sets warrantyMonth
     *
     * @param int|null $warrantyMonth number of months (device warranty)
     *
     * @return self
     */
    public function setWarrantyMonth($warrantyMonth)
    {
        $this->container['warrantyMonth'] = $warrantyMonth;

        return $this;
    }

    /**
     * Gets warrantyExpire
     *
     * @return int|null
     */
    public function getWarrantyExpire()
    {
        return $this->container['warrantyExpire'];
    }

    /**
     * Sets warrantyExpire
     *
     * @param int|null $warrantyExpire date when the warranty expires
     *
     * @return self
     */
    public function setWarrantyExpire($warrantyExpire)
    {
        $this->container['warrantyExpire'] = $warrantyExpire;

        return $this;
    }

    /**
     * Gets remark
     *
     * @return string|null
     */
    public function getRemark()
    {
        return $this->container['remark'];
    }

    /**
     * Sets remark
     *
     * @param string|null $remark Misc. remarks regarding the guarantee / warranty
     *
     * @return self
     */
    public function setRemark($remark)
    {
        $this->container['remark'] = $remark;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


